module Startup

//
// SF startup initialization
// note: these initializations are normally not required, but they can be 
// very important if running under a bootloader or you reset using a 'goto 0'
// initialization is enabled by default (since it shouldn't hurt anything),
// but you can disable this initialization by setting the option false.
// 
#option SYSTEM_SET_REGISTER_DEFAULTS = true

public inline sub SetRegisterDefaults()
    // v1.3 - init upper tableptr reg for 'const' data access
    TBLPTRU = $00
    
    // v1.4 - init bank select, pclat, and stkptr registers
    BSR = $00

    // these are probably fine, but they're very important, so just in case...
    PCLATU = $00
    PCLATH = $00
    STKPTR = $00

    // set FSR2 to 0 in case extended instruction config (XINST) is enabled
    FSR2 = 0
end sub

#if (SYSTEM_SET_REGISTER_DEFAULTS)
SetRegisterDefaults()
#endif

end module
